Unset LANG etc. to avoid non-standard command output from non-C locales.
[bpt/emacs.git] / admin / quick-install-emacs
CommitLineData
d9a88584
MB
1#!/bin/sh
2# quick-install-emacs -- do a halfway-decent job of installing emacs quickly
3# Written by Miles Bader <miles@gnu.org>
4
5# This script is mainly intended for emacs maintainer or pretesters who
6# install emacs very often. See the --help output for more details.
7
8PUBLIC_LIBSRC_BINARIES='b2m emacsclient etags ctags ebrowse'
9PUBLIC_LIBSRC_SCRIPTS='grep-changelog rcs-checkin'
10
c5915370 11AVOID="CVS -DIC README COPYING ChangeLog ~ \.orig$ \.rej$ Makefile makefile stamp-subdir .cvsignore \.[cho]$ make-docfile testfile test-distrib"
d9a88584
MB
12
13# Prune old binaries lying around in the source tree
14PRUNE=no
15# Re-install files even if they already exist
16FORCE=no
17# Command verbose flag
18VERBOSE=''
19
20me="`basename $0`"
21
22# Install commands (these commands are also expected to understand the
23# GNU -v (--verbose) option)
24LINK='cp -lf'
25COPY='cp -f'
26REMOVE='rm -r'
27
28# Used to execute commands once once we create them
29EXEC='sh'
30MKDIR='mkdir --verbose -p'
31
32NAWK=/usr/bin/nawk
33
a819ec1a
MB
34# avoid non-standard command output from non-C locales
35unset LANG LC_ALL LC_MESSAGES
36
d9a88584
MB
37# Some messages
38USAGE="Usage: $me [OPTION...] BUILD_TREE [PREFIX]"
39TRY="Try "\`"$me --help' for more information."
40
41# Parse command-line options
42while :; do
43 case "$1" in
44 -n|--dry-run)
45 EXEC=cat; shift;;
46 -p|--prune)
47 PRUNE=yes; shift;;
48 -P|--no-prune)
49 PRUNE=no; shift;;
50 --prune-only)
51 PRUNE=only; shift;;
52 -f|--force)
53 FORCE=yes; shift;;
54 -v|--verbose)
55 VERBOSE="-v"; shift;;
56 --help)
57 cat <<EOF
58$USAGE
59Install emacs quickly
60
61 -n, --dry-run print installation commands instead of
62 executing them
63
64 -f, --force install even files that haven't changed
65 -v, --verbose print messages describing what is done
66
67 -p, --prune prune old generated files
68 -P, --no-prune don't prune old generated files (default)
69 --prune-only prune old generated files, but don't install
70
71 --help display this help and exit
72 --version output version information and exit
73
74$me install emacs \`incrementally,' that is, it will
75install only those files that have changed since the last time it was
76invoked, and remove any obsolete files from the installation
77directories. It also uses hard-links into the source and build trees to
78do the install, so it uses much less space than the default Makefile
79install target; however, this also means that $me can
80not install onto a disk partition other than the one on which the source
81and build directories reside.
82
83Optionally, $me can also remove old versions of
84automatically generated files that are version-specific (such as the
85versioned emacs executables in the \`src' directory, and the DOC-* files
86in the \`etc' directory). The latter action is called \`pruning,' and
87can be enabled using the \`-p' or \`--prune' options.
88EOF
89 exit 0
90 ;;
91 --version)
92 cat <<EOF
93$me 1.5
94
95Written by Miles Bader <miles@gnu.org>
96EOF
97 exit 0
98 ;;
99 -[^-]?*)
100 # split concatenated single-letter options apart
101 FIRST="$1"; shift
102 set -- `echo $FIRST | sed 's/-\(.\)\(.*\)/-\1 -\2/'` "$@"
103 ;;
104 -*)
105 echo 1>&2 "$me: unrecognized option "\`"$1'"
106 echo 1>&2 "$TRY"
107 exit 1
108 ;;
109 *)
110 break;
111 esac
112done
113
114LINK_CMD="$LINK $VERBOSE"
115REMOVE_CMD="$REMOVE $VERBOSE"
116
117case $# in
118 1) BUILD="$1";;
119 2) BUILD="$1"; prefix="$2";;
120 *)
121 echo 1>&2 "$USAGE"
122 echo 1>&2 "$TRY"
123 exit 1
124 ;;
125esac
126
127if test ! -d "$BUILD"; then
128 echo 1>&2 "$me: $BUILD: Build tree not found"
129 exit 2
130elif test ! -r "$BUILD/config.status"; then
131 echo 1>&2 "$me: $BUILD: Not a proper build tree, config.status not found"
132 exit 2
133fi
134
135CONFIG_STATUS="$BUILD/config.status"
136function get_config_var () {
6461c636 137 if ! sed -n "s/^s\(.\)@$1@\1\(.*\)\1.*$/\2/p" $CONFIG_STATUS | sed q | grep ''
d9a88584
MB
138 then
139 echo 1>&2 "$me: $1: Configuration variable not found in $CONFIG_STATUS"
140 exit 4
141 fi
142}
143
c5915370
MB
144test x"$SRC" = x && { SRC="`get_config_var srcdir`" || exit 4 ; }
145test x"$prefix" = x && { prefix="`get_config_var prefix`" || exit 4 ; }
c5915370 146test x"$ARCH" = x && { ARCH="`get_config_var host`" || exit 4 ; }
d9a88584 147
892de428
MB
148VERSION=`grep 'defconst[ ]*emacs-version' $SRC/lisp/version.el \
149 | sed -e 's/^[^"]*"\([^"]*\)".*$/\1/'`
150
d9a88584
MB
151DST_SHARE="$prefix/share/emacs/$VERSION"
152DST_BIN="$prefix/bin"
153DST_LIBEXEC="$prefix/libexec/emacs/$VERSION/$ARCH"
154DST_INFO="$prefix/info"
155
156function maybe_mkdir () {
157 if ! test -d "$1"; then
158 $MKDIR "$1" 2>&1 | sed "s/^mkdir:/$me:/" 1>&2
159 fi
160}
161
162maybe_mkdir "$DST_BIN"
163maybe_mkdir "$DST_SHARE"
164maybe_mkdir "$DST_SHARE/site-lisp"
165maybe_mkdir "$DST_LIBEXEC"
166maybe_mkdir "$DST_INFO"
167
168( # start of command-generating sub-shell
169
170PRUNED=""
171if test x"$PRUNE" != xno; then
6461c636 172 for D in `ls -1t $BUILD/etc/DOC-* | sed 1d`; do
d9a88584
MB
173 echo $REMOVE_CMD $D
174 PRUNED="$PRUNED $D"
175 done
6461c636 176 for D in `ls -1t $BUILD/src/emacs-$VERSION.* | sed 1d`; do
d9a88584
MB
177 echo $REMOVE_CMD $D
178 PRUNED="$PRUNED $D"
179 done
6461c636 180 for D in `ls -1t $BUILD/lib-src/fns-* | sed 1d`; do
d9a88584
MB
181 echo $REMOVE_CMD $D
182 PRUNED="$PRUNED $D"
183 done
184fi
185
186test x"$PRUNE" = xonly && exit 0
187
188function maybe_emit_copy () {
189 if test "$FORCE" = yes || ! cmp -s $1 $2; then
190 echo $LINK_CMD $1 $2
191 fi
192}
193
194maybe_emit_copy $BUILD/src/emacs $DST_BIN/emacs
195maybe_emit_copy $BUILD/src/emacs $DST_BIN/emacs-$VERSION
196
197for F in $PUBLIC_LIBSRC_BINARIES; do
198 maybe_emit_copy $BUILD/lib-src/$F $DST_BIN/$F
199done
200for F in $PUBLIC_LIBSRC_SCRIPTS; do
201 maybe_emit_copy $SRC/lib-src/$F $DST_BIN/$F
202done
203
204if test x"$SRC" = x"$BUILD"; then
205 PFXS="$BUILD"
206else
207 PFXS="$SRC $BUILD"
208fi
209
210for SUBDIR in lisp leim etc lib-src info; do
211 # defaults
212 SHARED=no
213 FORCED=''
214 AVOID_PAT="`echo "($AVOID)" | tr ' ' '|'`"
215
216 # Set subdir-specific values
217 case $SUBDIR in
218 lisp|leim)
219 DST="$DST_SHARE/$SUBDIR"
220 ;;
221 etc)
222 DST="$DST_SHARE/$SUBDIR"
223 # COPYING is in the avoid list, but there should be a copy of it in
224 # the install etc dir, so make that here.
225 FORCED="$DST/COPYING"
226 ;;
227 lib-src)
228 DST="$DST_LIBEXEC"
229 AVOID_PAT="`echo "($AVOID ($PUBLIC_LIBSRC_BINARIES $PUBLIC_LIBSRC_SCRIPTS)\$)" | tr ' ' '|'`"
230 ;;
231 info)
232 DST="$DST_INFO"
233 SHARED=yes
234 ;;
235 esac
236
237 for PFX in $PFXS; do
238 if [ -d $PFX/$SUBDIR ]; then
239 for DIR in `(cd $PFX/$SUBDIR; find . -type d -print | sed 's@^./@@')`; do
240 if [ -d $DST/$DIR ]; then
241 echo Directory $DST/$DIR exists
242 else
243 echo Directory $DST/$DIR non-existant
244 if [ "`echo $DIR | egrep -v "$AVOID_PAT"`" ]; then
245 maybe_mkdir $DST/$DIR
246 fi
247 fi
248 done
249 diff -sqr $PFX/$SUBDIR $DST
250 fi
251 done | $NAWK '
252BEGIN {
253 src_pat = "^'"$SRC"'/'"$SUBDIR"'/"
254 build_pat = "^'"$BUILD"'/'"$SUBDIR"'/"
255 dst_pat = "^'"$DST"'/"
256 dst_pfx = "'"$DST"'/"
257 avoid_pat = "'"$AVOID_PAT"'"
258 force = ("'"$FORCE"'" == "yes")
259 shared = ("'"$SHARED"'" == "yes")
260 init_bool_array(pruned, "'"$PRUNED"'")
261 init_bool_array(forced, "'"$FORCED"'")
262}
263function init_bool_array(array, string, a,k)
264{
265 split (string, a)
266 for (k in a)
267 array[a[k]] = 1
268}
269function install(src, dst)
270{
271 if (! (src in pruned)) {
272 cp[src] = dst;
273 from[dst] = src;
274 delete rm[dst];
275 }
276}
277function update(src, dst, copy)
278{
279 if (src in pruned) {
280 rm[dst] = 1;
281 delete from[dst]
282 } else {
283 if (copy)
284 cp[src] = dst;
285 from[dst] = src;
286 delete rm[dst];
287 }
288}
289function uninstall(dst)
290{
291 if (!(dst in from))
292 rm[dst] = 1;
293}
294/^Directory / {
295 if ($2 ~ avoid_pat) {
296 if ($NF == "exists")
297 uninstall($2)
298 } else
299 update(0, $2, 0)
300 next
301}
302/^Files / {
303 if ($4 ~ avoid_pat && !($4 in forced))
304 uninstall($4)
305 else if ($NF == "identical")
306 update($2, $4, force)
307 else
308 update($2, $4, 1)
309 next
310}
311/^Only / {
312 pfx = $3
313 sub (/:$/, "/", pfx)
314
315 if (pfx ~ dst_pat) {
316 if (! shared)
317 uninstall(pfx $4)
318 } else {
319 subdir = pfx
320 if (subdir ~ src_pat)
321 sub (src_pat, "", subdir)
322 else
323 sub (build_pat, "", subdir)
324
325 dst = dst_pfx subdir $4
326 if (! (dst ~ avoid_pat))
327 install(pfx $4, dst)
328 }
329 next
330}
331END {
332 for (f in rm)
333 print "'"$REMOVE_CMD"' " f
334 for (f in cp)
335 print "'"$LINK_CMD"' " f " " cp[f]
336}
337'
338done
339
340) | eval $EXEC